<?php
/** @noinspection PhpUnusedPrivateFieldInspection */
declare(strict_types=1);

namespace IntiTest\Test\TestCase;

use Inti\Test\TestCase\WordPressTestCase;
use WP_User;

use function defined;
use function function_exists;
use function get_user_by;
use function realpath;

/**
 * Class WordPressTest
 *
 * @package IntiTest\Test\TestCase
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-test
 */
final class WordPressTest extends WordPressTestCase
{
    private array $config = [
        'db_connections' => [
            'default' => [
                'host' => 'localhost',
                'user' => 'root',
                'password' => 'password',
                'dbname' => 'inti_wp_test',
            ],
        ],
    ];

    public function testABSPATHIsDetected()
    {
        $expected = realpath(__DIR__ . '/../../wordpress') . '/';

        $this->assertTrue(defined('ABSPATH'));
        /** @noinspection PhpUnitMisorderedAssertEqualsArgumentsInspection */
        $this->assertEquals($expected, ABSPATH);
    }

    public function testCanRunWordPress()
    {
        $this->runApplication();
        $this->assertTrue(function_exists('get_user_by'));

        $user = get_user_by('ID', 1);
        $this->assertInstanceOf(WP_User::class, $user);
        $this->assertEquals('admin', $user->user_login);
    }
}
